/*
One of those Weeks Day 6
Copyright (c) 2008-2009 Blazing Games Inc.
Code written by Billy D. Spelchan

This program is free software; you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software 
Foundation; either version 2 of the License, or (at your option) any later 
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.ootw.converse
{
	// Adobe Imports
	import flash.display.SimpleButton;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.utils.getTimer;
		
	/**
	 * displays a message in an animated style. Currently supported styles are:
	 * SlowText - characterd are slowly added.
	 * ExplodingText - characters are addded from both ends of the message.
	 *
	 * @author Billy D. Spelchan
	 * @version 1.0
	 * Copyright (c) 2007 Blazing Games Inc. All Rights Reserved.
	*/
	public class AnimatedText
	extends EventDispatcher
	{
// *********************
// ***** CONSTANTS *****
// *********************

		public static const STRING_FINISHED_EVENT:String = "StringFinished";

		public static const SLOWTEXT:int = 0;
		public static const EXPLODINGTEXT:int = 1;

// *********************
// ***** VARIABLES *****
// *********************

		public var messageText:String;
		public var charsPerSecond:Number;
		public var outputTextField:TextField;
		public var animationMode:int;

		protected var curPosition:Number;
		protected var startTime:int;

// ***********************
// ***** CONSTRUCTOR *****
// ***********************

		public function AnimatedText()
		{
		}

// **************************************
// ***** Functions - Event handlers *****
// **************************************

		public function textUpdate(evt:Event)
		{
			var s:String;
			var curTime:int = getTimer();
			curPosition = charsPerSecond / 1000 * (curTime - startTime);
			if (curPosition >= messageText.length) {
				curPosition = messageText.length;
				s = messageText;
				outputTextField.removeEventListener(
						Event.ENTER_FRAME, textUpdate);
				var evnt:Event = new Event(STRING_FINISHED_EVENT);
				this.dispatchEvent(evnt);
			} else {
				if (animationMode == SLOWTEXT) {
					s = messageText.substr(0, curPosition);
				} else {
					s = messageText.substr(0, curPosition/2);
					s += messageText.substr(-curPosition/2, curPosition/2);
				}
			}
			outputTextField.text = s;
		}

// ***************************************
// ***** Functions - General control *****
// ***************************************

		public function setText(tf:TextField,s:String,mode:int=0,cps:Number=10)
		{
			messageText = s;
			charsPerSecond = cps;
			outputTextField = tf;
			animationMode = mode;
			curPosition = 0;
			startTime = getTimer();
			outputTextField.addEventListener(Event.ENTER_FRAME, textUpdate);
		}

	} // end class
} // end package


