﻿/*
One of those Weeks Day 6
Copyright (c) 2008-2011 Blazing Games Inc.
Code written by Billy D. Spelchan

This program is free software; you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software 
Foundation; either version 2 of the License, or (at your option) any later 
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.ootw.inventory
{
	// Adobe Imports
	import flash.display.Sprite;

	/**
	* Used by inventory items to provide information to the inventory box.
	*
	* @author Billy D. Spelchan
	* @version 1.0
	*/
	public interface IInventoryItem
	{
// ***** Functions - IInventoryItem required ********************************

		/**
		* @return The sprite to use as a cursor when the sprite is being used.
		*/
		function getCursor():Sprite;

		/**
		* @return the sprite used to represent the object in the inventory box.
		*/
		function getIcon():Sprite;

		/**
		* @return the name of the item
		*/
		function getItemName():String;
		
		/**
		* @return The color uint for the inventory bar selected glow
		*/
		function getItemInfo():Object;
		
		/**
		* @param htype sets the highlight state
		*/
		function setHighlight(htype:uint);
	} // end interface
} // end package
